<?php

// fetches exactly one value of a SQL query
function fetch_one_value($query){
global $dbi;
list($res)=sql_fetch_row(sql_query($query,$dbi),$dbi);
return $res;
}

// gets a unique number out of the database (hopefully, but quite quite sure...)
function unique_number(){
global $dbi;
srand(microtime()*1000000);
$num1=rand(1,1000000);
$num2=rand(1,1000000);
$num3=rand(1,1000000);
$call="$num1#$num2#$num3";
$origin = $_GET["origin"];

sql_query("INSERT INTO numbers (caller,origin) VALUES ('$call','$origin')", $dbi);
$sql="select num from numbers where caller='$call'";
return(fetch_one_value($sql,$dbi));
}

// replaces <BR> by /n
function replacebr($inp){
    return(str_replace("<BR>","\n",$inp));
}

// replaces \n by <BR>
function replacenl($inp){
    return(str_replace("\n","<BR>",$inp));
}

// deletes ', " and / around a string
function stripall($inp){
    $inp= str_replace("\"", "'", $inp);
    $inp= str_replace("/","'", $inp);
    while (substr($inp,0,1)=="'"){
        $inp=substr($inp,1,strlen($inp));
    }
    while (substr($inp,strlen($inp)-1,1)=="'"){
        $inp=substr($inp,0,$strlen-1);
    }
return $inp;
}

// replaces all whitespaces in a string with a single  " "
function scanner($inp){
    $inp=str_replace("\n"," ",$inp);
    $inp=str_replace("\t"," ",$inp);

    $inpar=split(" ",$inp);
        for ($i=0;$i<count($inpar);$i=$i+1){
            if ($inpar[$i]!=""){
            $outp=$outp.$inpar[$i]." ";
            }
        }
    return $outp;
}

// searches for an xml element, returns a parameter
function xmlpar($inp,$element, $par)
{
    //delete whitespaces
    $inp=scanner($inp);
    //search begin
    $beg=strpos($inp,"<$element");
    //search end
    $end=strpos($inp,">",$beg);
    //extract content
    $cont=substr($inp,$beg+strlen("<$element")+1,$end-($beg+strlen("<$element"))-1);
    //build associative array of parameters
    $carr=split(" ",$cont);
        for ($i=0;$i<count($carr);$i=$i+1){
            $pair=split("=",$carr[$i]);
            $assarr[$pair[0]]=$pair[1];
        }
    return stripall($assarr[$par]);
}

//does a string contain a substring?
function hassubstr($inp,$subs){
    $outp=str_replace($subs,"",$inp);
    return(strlen($inp)!=strlen($outp));
}

// search for the first occurence of an XML element, returns the string before this element
// if the element is not there, returns the whole string
function prexml($inp,$element){
    if (hassubstr($inp,"<$element ")){
    $beg=strpos($inp,"<$element");
    return(substr($inp,0,$beg));
    }else{
    return $inp;
    }
}

//return the first xlm element found.
//if no element ist found, return ""
function firstxml($inp,$element){
    if (hassubstr($inp,"<$element ")){
    $beg=strpos($inp,"<$element");
    //search end
    $end=strpos($inp,">",$beg);
    //extract content
    $cont=substr($inp,$beg,$end-$beg+1);
    return $cont;
    }else{
    }return "";
}

// returns the tail after the first occurence of xml element.
// if xml element ist not found, returns the NOTHING
function postxml($inp,$element){
    if (hassubstr($inp,"<$element ")){
    $beg=strpos($inp,"<$element");
    //search end
    $end=strpos($inp,">",$beg);
    return(substr($inp,$end+1,strlen($inp)-$end));
    }else{
    return "";
    }
}

// adds a parameter to a given sql element, returns the element
function addxmlpar($inp,$name,$value){
    $beg=strpos($inp,">");
    $lastsign=substr($inp,$beg-1,1);
    if ($lastsign=="/"){$beg=$beg-1;}
    $head=substr($inp,0,$beg);
    return("$head $name=$value />");
}
?>
